<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Handler_AdmAccounts extends Controller_Handler {
        
        public function before() {
            $this->model = new Model_Admin_Accounts();
            $this->setAccessLevel(self::ACCESS_USER);
            parent::before();
        }
        
        public function action_getActivationForTeachers()
        {
            $facultyID = $this->post->offsetGet('facultyID');
            $departmentsHandled = array(); $i = 0;
            $departments = $this->model->getDepartments($facultyID);
            foreach ($departments as $department)
            {
                $i++; $j = 0;
                $accounts = $this->model->getTeachersByDepartment($department['ID']);
                if ($accounts == null)
                    continue;
                $departmentsHandled[$i]['Name'] = $department['Name'];
                foreach ($accounts as $row)
                {
                    $accInfo = $this->model->getAccountInfo($row['AccountID']);
                    if($code = $accInfo->get('Code'))
                    {
                        $j++;
                        $departmentsHandled[$i]['People'][$j]['LastName'] = $row['Last'];
                        $departmentsHandled[$i]['People'][$j]['FirstName'] = $row['First'];
                        $departmentsHandled[$i]['People'][$j]['SecondName'] = $row['Second'];
                        $departmentsHandled[$i]['People'][$j]['ActivationCode'] = $code;
                    }
                }
                if($j == 0)
                {
                    $departmentsHandled[$i] = array();
                    $i--;
                }
            }
            if($i > 0)
            {
                $File = PDFCreator::CreatePDF(
                        'pdf/activationTeacher',
                        'media/css/pdf/activationTemplate.css',
                        array(
                            'Departments' => $departmentsHandled, 
                            'System' => array(
                                'Title' => ASSEMBLY_SYSTEM_NAME, 
                                'Version' => ASSEMBLY_VERSION
                                )
                            ));
                $Headers = PDFCreator::GetHeaders($File, 'ActivationTeachers'.$facultyID);
                foreach ($Headers as $key => $value) {
                    $this->response->headers($key, $value);
                }
                $this->response->body($File);
            }
            else {
                throw HTTP_Exception::factory(404, 'No data found');
            }
        }
        
        public function action_getActivationForStudents()
        {
            $facultyID = $this->post->offsetGet('facultyID');
            $gradeID = $this->post->offsetGet('gradeID');
            $groupsHandled = array(); $i = 0;
            $studyGroups = $this->model->getStudyGroups($gradeID, $facultyID);
            foreach ($studyGroups as $group)
            {
                $i++; $j = 0;
                $accounts = $this->model->getStudents($group['ID']);
                if (empty($accounts))
                    continue;
                $groupsHandled[$i]['Grade'] = $gradeID;
                $groupsHandled[$i]['Num'] = $group['GroupNum'];
                $groupsHandled[$i]['Spec'] = $group['SpecName'];
                foreach ($accounts as $row)
                {
                    $accInfo = $this->model->getAccountInfo($row['AccountID']);
                    if($code = $accInfo->get('Code'))
                    {
                        $j++;
                        $groupsHandled[$i]['People'][$j]['LastName'] = $row['Last'];
                        $groupsHandled[$i]['People'][$j]['FirstName'] = $row['First'];
                        $groupsHandled[$i]['People'][$j]['SecondName'] = $row['Second'];
                        $groupsHandled[$i]['People'][$j]['ActivationCode'] = $code;
                    }
                }
                if($j == 0)
                {
                    $groupsHandled[$i] = array();
                    $i--;
                }
            }
            if($i > 0)
            {
                $File = PDFCreator::CreatePDF(
                        'pdf/activationStudent',
                        'media/css/pdf/activationTemplate.css',
                        array(
                            'Groups' => $groupsHandled, 
                            'System' => array(
                                'Title' => ASSEMBLY_SYSTEM_NAME, 
                                'Version' => ASSEMBLY_VERSION
                                )
                            ));
                $Headers = PDFCreator::GetHeaders($File, 'ActivationStudents');
                foreach ($Headers as $key => $value) {
                    $this->response->headers($key, $value);
                }
                $this->response->body($File);
            }
            else {
                throw HTTP_Exception::factory(404, 'No data found');
            }
        }
}